#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const Console = __importStar(require("fp-ts/Console"));
const E = __importStar(require("fp-ts/Either"));
const IO = __importStar(require("fp-ts/IO"));
const T = __importStar(require("fp-ts/Task"));
const TE = __importStar(require("fp-ts/TaskEither"));
const function_1 = require("fp-ts/function");
const t = __importStar(require("io-ts"));
const io_ts_docopt_1 = require("io-ts-docopt");
const PathReporter = __importStar(require("io-ts/lib/PathReporter"));
const lerna_packages_1 = require("./lerna-packages");
const index_1 = require("./index");
const docstring = `
Usage:
    link-local-dependencies [<package>]

Options:
    package    Path or name of single package for which to install local dependencies
`;
const CommandLineOptions = (0, io_ts_docopt_1.withEncode)(t.type({
    '<package>': t.union([t.null, t.string]),
}), (a) => ({
    pkg: a['<package>'],
}));
const decodeDocopt = (0, function_1.flow)(io_ts_docopt_1.decodeDocopt, E.mapLeft((0, function_1.flow)((errors) => PathReporter.failure(errors).join('\n'), (error) => ({ type: 'docopt decode', error }))), TE.fromEither);
const exit = (code) => () => process.exit(code);
const main = (0, function_1.pipe)(TE.bindTo('options')(decodeDocopt(CommandLineOptions, docstring)), 
// FIXME: process.cwd should instead be exposed as a parameter
TE.bindW('packages', () => (0, lerna_packages_1.lernaPackages)(process.cwd())), TE.chainW(({ options, packages }) => options.pkg !== null
    ? (0, index_1.linkLocalDependenciesIn)(packages.map)(options.pkg)
    : (0, index_1.linkAllLocalDependencies)(packages.map, packages.list)), TE.getOrElseW((0, function_1.flow)(Console.error, IO.chain(() => exit(1)), T.fromIO)));
main();
// Local Variables:
// mode: typescript
// End:
//# sourceMappingURL=link-local-dependencies.js.map